#!/usr/bin/python
import os
import sys
import json
import logging
import urllib2
import time
import zipfile
import urllib


def start_playback_app(movie_info):
    logging.info("start_playback " + str(movie_info))

    for sup in movie_info["movieInfo"]["publications"]:
        if sup["sup_id"] == "youku":
            # May be useful to use 'zh' language instead of 'en'.
            return start_youku(sup["id"], movie_info["movieInfo"]["title"]["en"])

    return {"error": {"message": str("Internal error 01")}}


def start_youku(mID, title=False, search=False):
    logging.info("start_youku youkuID=%s, title=%s, search=%s", mID, title, search)

    cmd=""
    package=""
    wait_app_start_delay=10

    if os.path.isdir("/data/data/com.cibn.tv"):
        cmd = "am start -a android.intent.action.VIEW -d 'cibntv_yingshi://play/youku?fileId=%s=='" % mID
        package = "com.cibn.tv"
    else:
        res = {"error": {
            "missing_app": {
                "title": str("Youku"),
                "package": str("com.cibn.tv"),
                "indirect": True,
                "urls": [str("http://online.dune-hd.com/apk/youku.txt")]
            },
            "message": str("Youku not installed.")
        }}
        logging.info("return %s", json.dumps(res))
        return res

    return {"bin": cmd, "package": package, "wait_app_start_delay": wait_app_start_delay}


if __name__ == '__main__':
    if len(sys.argv) != 2:
        print "Usage: %s start_playback_app" % sys.argv[0]
        sys.exit(1)

    logging.basicConfig(level=logging.DEBUG)
    logging.info(sys.argv)
    logging.info("uid: {} gid: {}".format(os.getuid(), os.getgid()))
    cmd = sys.argv[1]
    try:
        res = None
        if cmd == "start_playback_app":
            res = start_playback_app(json.load(sys.stdin))
        else:
            res = {"error": {"message": "Internal error 02 (%s)" % cmd}}  
    
    except Exception, ex:
        logging.exception('')
        msg = "Internal error 03 (" + str(ex) + ")"
        res = {"error": {"message": msg}}   

    if res != None:
        json.dump(res, sys.stdout)
